/*
 *  TSPwb_
 *
 *  $Id:$
 */

struct TSP_PIX{
  unsigned char a,r,g,b ;
} ;

/** define for TSP_CHIP.tyep **/
#define TSP_16   16
#define TSP_32   32
#define TSP_64   64
#define TSP_128 128

struct TSP_CHIP{
  int type ;
  struct TSP_PIX *map ;
} ;

struct TSP_SP{
  int x , y ;
  int vx,vy ;
  int v , h ;
  int pcg   ;
  int dummy ;
} ;

struct TSP_PCG{
  struct TSP_CHIP *chip   ;
  int              num    ;
  int              cur    ;
  struct TSP_SP   **sp    ;
  int              sp_max ;
  int              sp_cur ;
} ;

struct TSP_PCG tsp_pcg ;

struct TSP_WINDOW{
  int real_width ;
  int width ;
  int height ;
  volatile struct TSP_PIX *vram ;
} ;

#define TSP_PCG_INIT_ERROR          -1
#define TSP_SP_INIT_ERROR           -2
#define TSP_PCG_AREA_FULL           -3
#define TSP_MALLOC_ERROR            -4
#define TSP_INVALID_WINDOW_ERROR    -5
#define TSP_SP_AREA_FULL            -6

int add_pcg( struct TSP_PIX *map, int type ) ;
int draw_sp( struct TSP_WINDOW *win ) ;
int init_pcg( int pcg_num ) ;
int init_sp( int sp_num ) ;
struct TSP_WINDOW* init_window() ;
